function [F,A,C,I] = A_plot_matrix(Mat, CLIM, F, T, sh, MOD_i, MOD_NAMES)
% [F,A,C,I] = plot_FNC(FNC, CLIM, LABEL, RSN_I, F, T)

% define the size of each "MODULE"
%MOD = [4, 2, 8, 10, 14, 9];
if (~exist('MOD_i', 'var'))
    MOD_i= ones(1, size(Mat,2));
    MOD_j= ones(1, size(Mat,1));
end
cMOD_i = cumsum(MOD_i);
cMOD_j = cumsum(MOD_j);

if (~exist('MOD_NAMES', 'var'))
    MOD_NAMES = [];
end

if (~isempty(MOD_NAMES))
    tmpNames = repmat({''}, sum(MOD_i), 1);
    
    for nM = 1:length(MOD_NAMES)
        indx = ceil(MOD_i(nM)/2);
        if (nM > 1)
            indx = indx + sum(MOD_i(1:nM - 1));
        end
        tmpNames{indx} = MOD_NAMES{nM};
    end
    MOD_NAMES = tmpNames;
end


if ~exist('T', 'var') || isempty(T)
    T = 'covariance';
end

if ~exist('F', 'var') || isempty(F)
    F = figure('Color', 'w');
end

set(F, 'invertHardcopy', 'off');

if (~exist('sh', 'var'))
    sh = gca;
end

bgColor = get(F, 'color');
if (all(bgColor == 0))
    foregroundcolor = 'w';
else
    foregroundcolor = 'k';
end


%imagesc(FNC, CLIM);
A_pcolor(1:size(Mat,1), 1:size(Mat,2), Mat');
set(sh, 'clim', CLIM); axis ij
set(gca,'XTick',[]);
% sh.FontSize = 9;
c = get(sh, 'Children');
set(c(find(strcmp(get(c, 'Type'),'line'))), 'Color', bgColor);
set(c(size(Mat,2)-cMOD_i+1), 'Color', foregroundcolor)
set(c(size(Mat,2)+size(Mat,1)+2-cMOD_j), 'Color', foregroundcolor)
uistack(c(size(Mat,2)+size(Mat,1)+2-cMOD_j), 'top')
A = sh;
% sh.FontSize = 9;
I = c(find(strcmp(get(c, 'Type'),'image')));
C = colorbar;
set(C,'Fontsize',18);
set(get(C, 'YLabel'), 'String', T,'Fontsize',18)
set(gca,'XTick',1:size(Mat,1));
% set(gca,'YTick',[]);

try
    set(C, 'color', foregroundcolor);
    set(get(C, 'label'), 'color', foregroundcolor);
catch
end

%% labeling
% LABEL = cellstr(num2str(1:size(Mat,1)));
% RSN_I = 1:size(Mat,1);
% if exist('LABEL', 'var') && ~isempty(LABEL)
%     
%     set(A, 'YTick', 1:length(RSN_I), 'YTickLabel', LABEL(RSN_I), 'TickDir', 'out', 'XTick', 1:length(RSN_I),'XTickLabel',[]);
%     b = get(A, 'XTick');
%     c=get(A,'YTick');
%     ypos = c(end) +1.25;
%     th=text(1:length(b),repmat(ypos,length(b),1), LABEL(RSN_I),'HorizontalAlignment','right','rotation',90, ...
%         'color', foregroundcolor);
% end
% 
%% labeling
% if exist('MOD_NAMES', 'var') && ~isempty(MOD_NAMES)
%     
%     %set(A, 'YTick', 1:length(RSN_I), 'YTickLabel', MOD_NAMES(RSN_I), 'TickDir', 'out', 'XTick', 1:length(RSN_I),'XTickLabel',[]);
%     b = get(A, 'XTick');
%     c=get(A,'YTick');
%     ypos = c(end) + 4;
%     xpos = b(end) + 4;
%     th=text(repmat(-4,length(b),1), 1:length(b), MOD_NAMES(RSN_I),'HorizontalAlignment','right','rotation',90, ...
%         'color', foregroundcolor, 'fontweight', 'bold');
%     th=text(1:length(c),repmat(xpos,length(c),1), MOD_NAMES(RSN_I),'HorizontalAlignment','right','rotation',90, ...,
%         'color', foregroundcolor, 'fontweight', 'bold');
% end
% 
% 
% if exist('RSN_I', 'var') && ~isempty(RSN_I)
%     hold on;
%     
%     for ii = 1:length(RSN_I);
%         T =text(ii,ii,num2str(RSN_I(ii)));
%         set(T, 'Color', foregroundcolor, 'HorizontalAlignment', 'Center');
%     end
% end