function [BestN,IDXall] = get_clusters(data,N_max,Nrun,method,varargin)
% ----------- by Q. Long ------ Oct 2020 --------------------%
% ----------- Updated by H. Yang ------ Sep 2023 --------------------%

if method==3
    Params=struct('COV_mat',[]);
    Params=getopt(Params,varargin{:});
    if isfield(Params,'COV_mat')
        COV_mat = Params.COV_mat;
    else
        error('Please provide the corresponding matrices of the rows in data (method 3)')
    end
end


if method == 2
    for run = 1:Nrun
        results = icatb_optimal_clusters(data, N_max, 'method','all', 'distance', 'Correlation');
        method_ind = 1; % here only extract the result using 'elbow'
        N_all(run) = results{1,method_ind}.K;
    end
    BestN = round(mean(N_all));
    IDXall = [];
    
elseif method == 3
    DEV = std(data, [], 2);
    [~, imax, ~, ~] = icatb_extrema(DEV);
    if length(imax) < N_max
        error ('The rows of data should be greater the number of clusters, change "cov_t" or "q_t" or "N_max" to avoid this error')% Hanlu: add error message to avoid clustering errors
    end 
    
    Cp = data(imax,:);
    N_all = 2:N_max; %Hanlu: Changed from N_all = 3:N_max to avoid empty cell values, and make sure satisfy "number of clusters must be greater than 1"
    Q = zeros(Nrun,length(N_all));
    IDXall = cell(length(N_all),1);Call = cell(length(N_all),1);SUMDall = cell(length(N_all),1);Dall = cell(length(N_all),1);
    for idx = 1:length(N_all)
        Q_temp = zeros(Nrun,N_all(idx));
        for run = 1:Nrun
%             [~, Cent, ~, ~] = icatb_kmeans(Cp, N_all(idx), 'distance', 'Correlation',...
%                 'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop');
%             [IDXall{idx}(:,run), Call{idx}(:,:,run), SUMDall{idx}(:,run), Dall{idx}(:,:,run)] = icatb_kmeans(data, N_all(idx), 'distance', 'Correlation',...
%                 'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop','Start',Cent);
%             
           
                opts_1 = struct( 'distance', 'Correlation',...
                    'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop'); % Hanlu: update input options for icatb_kmeans_clustering accordingly
                [~, Cent, ~, ~] = icatb_kmeans_clustering(Cp,  N_all(idx), opts_1);% Hanlu: replace icatb_kmeans --> icatb_kmeans_clustering
                
                opts_2 = struct(  'distance', 'Correlation',...
                    'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop','Start',Cent);
                [IDXall{idx}(:,run), Call{idx}(:,:,run), SUMDall{idx}(:,run), Dall{idx}(:,:,run)] = icatb_kmeans_clustering(data, N_all(idx), opts_2);
           
                
                
            
            for i = 1:N_all(idx)
                eval(['idx_temp = find(IDXall{idx}(:,run)==',num2str(i),');']);
                COV_temp = mean(squeeze(COV_mat(:,:,idx_temp)),3);
                [~,Q_temp(run,i)]=modularity_und(COV_temp);% get the modularity of the mean COV of each cluster
            end
            clear COV_temp
        end
        Q(:,idx) = mean(Q_temp,2);clear Q_temp
    end
    [~,N_idx] = max(mean(Q));
    BestN = N_all(N_idx);clear idx i
    [~,BestRun] = max(Q(:,N_idx));% find the run with the largest modularity
    IDXall = squeeze(IDXall{N_idx}(:,BestRun));
end