function [subj_idx_module,COV_mean,COV_mean_module,IC_groups_idx] = identify_subgroups(COV_mat_2nd,IDSCVall,K,N_cluster_SCV,N_subgroups,method)
% ----------- by Q. Long ------ Oct 2020 --------------------%
% ----------- Updated by H. Yang ------ Sep 2023 --------------------%

COV_mean = zeros(K,K,N_cluster_SCV);% mean COV of clusters
COV_mean_module = zeros(K,K,N_cluster_SCV); % mean COV with modules that correspond to subgroups
subj_idx_module = cell(N_cluster_SCV,1);% the subject indices of subgroups in each cluster
IC_groups_idx = cell(N_cluster_SCV,1);% SCV indices of clusters


switch method
    case 'modularization'
        Q = zeros(N_cluster_SCV,1);
        for i = 1:N_cluster_SCV
            eval(['idx_temp = find(IDSCVall==',num2str(i),');']);
            IC_groups_idx{i} = idx_temp;
            COV_mean(:,:,i) = mean(squeeze(COV_mat_2nd(:,:,idx_temp)),3);
            [Ci,Q(i)]=modularity_und(COV_mean(:,:,i));
            N_subgroups = max(Ci);
            idx_module = [];
            subj_idx_module{i} = cell(N_subgroups,1);
            for j = 1:N_subgroups
                subj_idx_module{i}{j} = find(Ci==j);
                idx_module = [idx_module; find(Ci==j)];
            end
            COV_mean_module(:,:,i) = COV_mean(idx_module,idx_module,i);clear idx_module
        end
        
    case 'clustering'
        for i = 1:N_cluster_SCV
            eval(['idx_temp = find(IDSCVall==',num2str(i),');']);
            IC_groups_idx{i} = idx_temp;
            COV_mean(:,:,i) = mean(squeeze(COV_mat_2nd(:,:,idx_temp)),3);
            
            if N_subgroups==0
                % get_clusters(data,N_max,Nrun,method,varargin)
                N_subgroups = get_clusters(squeeze(COV_mean(:,:,i)),6,100,2);% #runs set as 100, can change. read 'icatb_optimal_clusters.m', N_max should be >5
            end
            DEV = std(squeeze(COV_mean(:,:,i)), [], 2);
            [~, imax, ~, ~] = icatb_extrema(DEV);
            Cp = squeeze(COV_mean(imax,:,i));
            clear IDXall SUMDall
            for run = 1:10 % can change #runs
                

%                 [~, Cent, ~, ~] = icatb_kmeans(Cp, N_subgroups, 'distance', 'Correlation',...
%                     'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop');
%                 [IDSGsall(:,run), ~, SUMSGsall(:,run), ~] = icatb_kmeans(squeeze(COV_mean(:,:,i)), N_subgroups, 'distance', 'Correlation',...
%                     'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop','Start',Cent);
%
                opts_1 = struct( 'distance', 'Correlation',...
                    'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop'); % Hanlu: update input options for icatb_kmeans_clustering accordingly
                [~, Cent, ~, ~] = icatb_kmeans_clustering(Cp, N_subgroups, opts_1);% replace icatb_kmeans --> icatb_kmeans_clustering
                
                opts_2 = struct(  'distance', 'Correlation',...
                    'Replicates', 1, 'Display', 'iter', 'MaxIter', 150, 'empty', 'drop','Start',Cent);
                [IDSGsall(:,run), ~, SUMSGsall(:,run), ~] = icatb_kmeans_clustering(squeeze(COV_mean(:,:,i)), N_subgroups, opts_2);
            end
            [~,best_run] = min(mean(SUMSGsall,1));
            IDSGsall = IDSGsall(:,best_run);
            idx_module = [];
            subj_idx_module{i} = cell(N_subgroups,1);
            for j = 1:N_subgroups
                subj_idx_module{i}{j} = find(IDSGsall==j);
                idx_module = [idx_module; find(IDSGsall==j)];
            end
            COV_mean_module(:,:,i) = COV_mean(idx_module,idx_module,i);clear idx_module
        end
        
    case 'gershgorin' 
        % Added by Hanlu. Subgroups based on Gershgorin doesn't requrie a
        % predifined number of subgroup since it detects the number of
        % subgroup automatically. 
        for i = 1:N_cluster_SCV
            eval(['idx_temp = find(IDSCVall==',num2str(i),');']);
            IC_groups_idx{i} = idx_temp;
            COV_mean(:,:,i) = mean(squeeze(COV_mat_2nd(:,:,idx_temp)),3);
        end
        [Gdisc_subj_idx_module_,COV_mean_module]= Gdisc_subgroup(COV_mean);
        subj_idx_module = Gdisc_subj_idx_module_';

    
        
end