function plot_COV(COV_vec,q)
%%% This is a supplementary function of function 'Finding_clusters_auto' that 
%%% plots the distribution of the correlation/covariance values of SCVs 
%%% that are sorted by q. Other criteria can be used as well.

%%% input should be a matrix of M x N, each column is a vectorized
%%% correlation/covariance matrix, hence totally there are N vectors

% two thresholds determined by users to help determine the input
% 'threshold' and 'q_t' of function 'Finding_clusters_auto'
t1 = 0.6; 
t2 = 0.2;

[~,q_idx] = sort(q,'descend');
figure
hold on
for n = 1:size(COV_vec,2)
    distributionPlot(squeeze(COV_vec(:,q_idx(n))),'histOri','center','xvalues',n,'color','b','distWidth',0.6);
end
plot(0:86,ones(1,87)*t1,'.-','LineWidth',MyLine+1,'MarkerSize',1,'Color',[0.2,0.8,1])
plot(0:86,ones(1,87)*t2,'.-','LineWidth',MyLine+1,'MarkerSize',1,'Color','m')
plot(1:85,q(q_idx),'.-','LineWidth',MyLine+1,'MarkerSize',MyMark)
xval = 1:size(COV_vec,2);
xlabels = q_idx;
xlim([0 size(COV_vec,2)+1]);%ylim([0 100]);
xlabel('SCV (sorted by q)','FontSize',MyFont+10,'FontWeight','bold');
ylabel('Covariance','FontSize',MyFont+10,'FontWeight','bold');
set(gca,'FontSize',MyFont,'XTick',xval,'XTickLabel',xlabels,'XAxisLocation','bottom');
ylim = get(gca, 'YLim');
h=gcf; 
pos1 = get(h,'Position');
set(h,'Position',[pos1(1) pos1(2) 2800 1000]);%[1600 600][3000 1200][2800 1000]
% pause(2);
% hgexport(gcf,'COV_PDFplot_SORTmean_rate',epsfig,'Format','eps')
% eps2pdf('COV_PDFplot_SORTmean_rate.eps', '/usr/local/bin/gs');

end